#include "partition.h"
#include<bits/stdc++.h>
using namespace std;

const int MAXN = 1e7 + 5;
bool chetnost[MAXN], first[MAXN];
vector<int> pos[MAXN];

bool is_pow2(int a)
{
    while(a % 2 == 0)
    {
        a /= 2;
    }
    if(a == 1)
    {
        return true;
    }
    else
    {
        return false;
    }
}

vector<int> solve(vector<int> A)
{
    bool Case = false;
    for(int i = 0; i < A.size(); i++)
    {
        if(A[i] != i + 1)
        {
            Case = true;
        }
    }
    if(Case)
    {
        for(int i = 0; i < MAXN; i++)
        {
            chetnost[i] = false;
        }
        vector<int> otg1, otg2;
        for(int i = 0; i < A.size(); i++)
        {
            if(!chetnost[A[i]])
            {
                otg1.push_back(i);
                chetnost[A[i]] = true;
            }
            else
            {
                otg2.push_back(i);
                chetnost[A[i]] = false;
            }
        }
        vector<int> otg;
        for(int i = 0; i < otg1.size(); i++)
        {
            otg.push_back(otg1[i]);
        }
        for(int i = 0; i < otg2.size(); i++)
        {
            otg.push_back(otg2[i]);
        }
        return otg;
    }
    vector<int> otg, otg1, otg2;
    if(A.size() % 2 == 0)
    {
        for(int i = 0; i < A.size(); i++)
        {
            if(i % 2 == 1)
            {
                otg1.push_back(i);
                otg1.push_back(A.size() - i - 1);
            }
            else
            {
                otg2.push_back(i);
                otg2.push_back(A.size() - i - 1);
            }
        }
    }
    else
    {
        otg1.push_back(0);
        for(int i = 1; i < A.size(); i++)
        {
            if(i % 2 == 1)
            {
                otg1.push_back(i);
                otg1.push_back(A.size() - i - 1);
            }
            else
            {
                otg2.push_back(i);
                otg2.push_back(A.size() - i - 1);
            }
        }
    }

    for(int i = 0; i < otg1.size(); i++)
    {
        otg.push_back(otg1[i]);
    }
    for(int i = 0; i < otg2.size(); i++)
    {
        otg.push_back(otg2[i]);
    }
    return otg;
}
